/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code!
 *
 * The version of the OpenAPI document: 0.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { Highlight, HighlightUpdate, Highlights, NewHighlight } from '../models';
export interface AddHighlightRequest {
    highlight: NewHighlight;
}
export interface DeleteHighlightRequest {
    id: string;
}
export interface GetHighlightsRequest {
    sourceType?: GetHighlightsSourceTypeEnum;
    scopeId?: string;
    sourceIds?: Array<string>;
    color?: GetHighlightsColorEnum;
    page?: number;
    perPage?: number;
}
export interface UpdateHighlightRequest {
    id: string;
    highlight: HighlightUpdate;
}
/**
 * no description
 */
export declare class HighlightsApi extends runtime.BaseAPI {
    /**
     * Add a highlight with an optional note
     * Add a highlight
     */
    addHighlightRaw(requestParameters: AddHighlightRequest): Promise<runtime.ApiResponse<Highlight>>;
    /**
     * Add a highlight with an optional note
     * Add a highlight
     */
    addHighlight(requestParameters: AddHighlightRequest): Promise<Highlight>;
    /**
     * Delete a highlight. Can only be done by the owner of the highlight.
     * Delete a highlight
     */
    deleteHighlightRaw(requestParameters: DeleteHighlightRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * Delete a highlight. Can only be done by the owner of the highlight.
     * Delete a highlight
     */
    deleteHighlight(requestParameters: DeleteHighlightRequest): Promise<void>;
    /**
     * Get filtered highlights belonging to the calling user.  Highlights can be filtered thru query parameters:  source_type, scope_id, source_ids, and color.  Results are paginated and ordered.  When source_ids are specified, the order is order within the sources.  When source_ids are not specified, the order is by creation time.  Example call:   /api/v0/highlights?source_type=openstax_page&scope_id=123&color=yellow
     * Get filtered highlights
     */
    getHighlightsRaw(requestParameters: GetHighlightsRequest): Promise<runtime.ApiResponse<Highlights>>;
    /**
     * Get filtered highlights belonging to the calling user.  Highlights can be filtered thru query parameters:  source_type, scope_id, source_ids, and color.  Results are paginated and ordered.  When source_ids are specified, the order is order within the sources.  When source_ids are not specified, the order is by creation time.  Example call:   /api/v0/highlights?source_type=openstax_page&scope_id=123&color=yellow
     * Get filtered highlights
     */
    getHighlights(requestParameters: GetHighlightsRequest): Promise<Highlights>;
    /**
     * Update a highlight
     * Update a highlight
     */
    updateHighlightRaw(requestParameters: UpdateHighlightRequest): Promise<runtime.ApiResponse<Highlight>>;
    /**
     * Update a highlight
     * Update a highlight
     */
    updateHighlight(requestParameters: UpdateHighlightRequest): Promise<Highlight>;
}
/**
    * @export
    * @enum {string}
    */
export declare enum GetHighlightsSourceTypeEnum {
    OpenstaxPage = "openstax_page"
}
/**
    * @export
    * @enum {string}
    */
export declare enum GetHighlightsColorEnum {
    Yellow = "yellow",
    Green = "green",
    Blue = "blue",
    Purple = "purple",
    Red = "red"
}
