/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code!
 *
 * The version of the OpenAPI document: 0.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface InfoData
 */
export interface InfoData {
    /**
     * The total number of highlights
     * @type {number}
     * @memberof InfoData
     */
    totalHighlights?: number;
    /**
     * The average number of highlights per user
     * @type {number}
     * @memberof InfoData
     */
    avgHighlightsPerUser?: number;
    /**
     * The max number of highlights used by any one user
     * @type {number}
     * @memberof InfoData
     */
    maxNumHighlightsAnyUser?: number;
    /**
     * The total number of notes/annotations
     * @type {number}
     * @memberof InfoData
     */
    totalNotes?: number;
    /**
     * The average length (chars) of a note
     * @type {number}
     * @memberof InfoData
     */
    avgNoteLength?: number;
}
export declare function InfoDataFromJSON(json: any): InfoData;
export declare function InfoDataFromJSONTyped(json: any, ignoreDiscriminator: boolean): InfoData;
export declare function InfoDataToJSON(value?: InfoData | null): any;
