/* tslint:disable */
/* eslint-disable */
/**
 * OpenStax Highlights API
 * The highlights API for OpenStax.  Requests to this API should include `application/json` in the `Accept` header.  The desired API version is specified in the request URL, e.g. `[domain]/highlights/api/v0/highlights`. While the API does support a default version, that version will change over time and therefore should not be used in production code! 
 *
 * The version of the OpenAPI document: 0.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface InfoData
 */
export interface InfoData {
    /**
     * The total number of highlights
     * @type {number}
     * @memberof InfoData
     */
    totalHighlights?: number;
    /**
     * The average number of highlights per user
     * @type {number}
     * @memberof InfoData
     */
    avgHighlightsPerUser?: number;
    /**
     * The max number of highlights used by any one user
     * @type {number}
     * @memberof InfoData
     */
    maxNumHighlightsAnyUser?: number;
    /**
     * The total number of notes/annotations
     * @type {number}
     * @memberof InfoData
     */
    totalNotes?: number;
    /**
     * The average length (chars) of a note
     * @type {number}
     * @memberof InfoData
     */
    avgNoteLength?: number;
}

export function InfoDataFromJSON(json: any): InfoData {
    return InfoDataFromJSONTyped(json, false);
}

export function InfoDataFromJSONTyped(json: any, ignoreDiscriminator: boolean): InfoData {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'totalHighlights': !exists(json, 'total_highlights') ? undefined : json['total_highlights'],
        'avgHighlightsPerUser': !exists(json, 'avg_highlights_per_user') ? undefined : json['avg_highlights_per_user'],
        'maxNumHighlightsAnyUser': !exists(json, 'max_num_highlights_any_user') ? undefined : json['max_num_highlights_any_user'],
        'totalNotes': !exists(json, 'total_notes') ? undefined : json['total_notes'],
        'avgNoteLength': !exists(json, 'avg_note_length') ? undefined : json['avg_note_length'],
    };
}

export function InfoDataToJSON(value?: InfoData | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'total_highlights': value.totalHighlights,
        'avg_highlights_per_user': value.avgHighlightsPerUser,
        'max_num_highlights_any_user': value.maxNumHighlightsAnyUser,
        'total_notes': value.totalNotes,
        'avg_note_length': value.avgNoteLength,
    };
}


